# AION_gateware

This repository is used to generate gateware for the ARTIQ hardware in the AION collaboration.

This repository is designed to be run on Gitlab and spawns a CI pipeline to build the firmware in the cloud. You can download the latest builds from the artifacts associated with this repository. These can be flashed to an ARTIQ rack by following the instructions in "Flashing the board" (see https://gitlab.com/aion-physics/code/aion_gateware/-/issues/1 to track progress on improving this deployment method).

The pipeline depends on Docker for reproducibility. The Docker images containing Nix, ARTIQ and Vivado are built separately in https://gitlab.com/aion-physics/code/vivado-docker, and hosted in the container registry associated with that project. They are huge: ~30GB, which is too large for a normal Gitlab cloud instance to build. You therefore must run any pipelines which build or use these images in a custom Gitlab runner with at least 200GB HD space, and not on a Windows host.

The "Local Installation Instructions" are only needed if you want to build the images locally instead of using the versions built in the cloud.

## Flashing the boards (new version)

Prerequisites:

1. A PC running linux (not WSL - sorry)
2. Nix installed with flakes enabled
   (use `mkdir -p ~/.config/nix && echo 'experimental-features = nix-command flakes' >> ~/.config/nix/nix.conf` to enable flakes)

Steps:

1. Connect your ARTIQ crate to your computer using USB and power it
2. Run `nix run --refresh git+https://gitlab.com/aion-physics/code/artiq/bitstreams/aion_gateware iclmaster` replacing "iclmaster" with your target crate.
3. If required, update your `device_db.py` in your experiment repo.

## Device_db

1. Run `nix build --refresh git+https://gitlab.com/aion-physics/code/artiq/bitstreams/aion_gateware#device_dbs.device-db-icl` replacing "icl" with your institute shortcode.
2. Copy the contents of the newly created file `result` into your `device_db.py`.

## Download the device_db

If you have changed the modules in the artiq crates, you may need to update your device_db. This has been autogenerated and built at the same time as the gateware. It can be found under "build-device-dbs" and "Download" the "Job artifacts". This contains the files for everyones systems so just choose the relevant one. You can replace the contents of your existing device_db with the contents of this new one or just copy the relevant parts over if you need to.

## Flashing the board (old version)

You now need to connect to the kasli using OpenOCD and flash the board.

Download the built images for your system from the artifacts of this project. Unpack them to a directory and navigate to this output directory.

Create a flash image using a predetermined mac and ip address (or run one of the scripts in your institute's directory):
```
artiq_mkfs flash_storage.img -s mac 02:29:37:66:75:A4 -s ip 10.255.13.34
```

To flash the image to the kasli board itself you need to use the `artiq_flash` command ([source](https://github.com/m-labs/artiq/blob/master/artiq/frontend/artiq_flash.py)). Direct it to use a src build, and the directory you output into during the gateware compilation stage.
```
artiq_mkfs flash_storage.img -s mac 02:29:37:66:75:A4 -s ip 10.255.13.34
artiq_flash -f flash_storage.img storage gateware bootloader firmware start -d bin --srcbuild -V kasli_main
```

For this example, my gateware was compiled into `bin`, and the `kasli_main` variant is desired. The file structure looks like so after compilation:
```
bin/
  kasli_main/
    gateware/
    software/
  someothervariant/
    gateware/
    software/
```

## Flashing Urukuls

_(Note that Urukuls purchased from technosystem are flashed before delivery)_

* Install `xc3sprog` which is used for the USB JTAG programmer
```
sudo apt install xc3sprog
```


# Local Installation Instructions

Instructions are for a Linux machine, Ubuntu.

## Getting started

1. Install the `nix` package manager, following the [instructions](https://m-labs.hk/artiq/manual/installing.html#installing-via-nix-linux) in the artiq installation guide.

2. Install Vivado following the [instruction](https://m-labs.hk/artiq/manual/developing.html) in the artiq installation guide.

# Detailed Instructions

This section holds the full instructions I used on a fresh installation of Ubuntu 20.04.2 (LTS).

## Install Nix package manager

First up, install the nix package manager.
```
curl -L https://nixos.org/nix/install | sh
```

For some reason my clean ubuntu install appeared to have a remnant of a broken nix install on it. Shrug. I cleaned it out and carried on with the install.

## Configure Nix channels

Now we follow the [install guide](https://m-labs.hk/artiq/manual/installing.html#installing-via-nix-linux). Add the M-Labs nix channels:
```
nix-channel --add https://nixbld.m-labs.hk/channel/custom/artiq/full/artiq-full
nix-channel --remove nixpkgs
nix-channel --add https://nixos.org/channels/nixos-21.05 nixpkgs
nix-channel --update
```

As per the guide, create the `~/.config/nix/nix.conf` file with contents:
```
substituters = https://cache.nixos.org https://nixbld.m-labs.hk
trusted-public-keys = cache.nixos.org-1:6NCHdD59X431o0gWypbMrAURkbJ16ZPMQFGspcDShjY= nixbld.m-labs.hk-1:5aSRVA5b320xbNvu30tqxVPXpld73bhtOeH6uAjRyHc=
```
This will let you use packages supplied by M-labs rather than having to download and build it all yourself.

NB: If later you get the following warning:
```
warning: ignoring untrusted substituter 'https://cache.nixos.org'
warning: ignoring untrusted substituter 'https://nixbld.m-labs.hk'
warning: ignoring the user-specified setting 'trusted-public-keys', because it is a restricted setting and you are not a trusted user
```
then you may need to recursively change the ownership of the `/nix/` store folder to the account you are using, e.g. `sudo chown labadmin /nix/ -R -v` for the 'labadmin' local account.

## Get the nix artiq environment scripts

To build the gateware requires the artiq git source. Clone it:
```
git clone https://github.com/m-labs/artiq
```
you also need the artiq nix scripts:
```
git clone https://git.m-labs.hk/m-labs/nix-scripts
```

## Start the nix artiq environment

You can start the nix environment with:
```
nix-shell -I artiqSrc=~/artiq ~/nix-scripts/artiq-fast/shell-dev.nix
```
where the above assumes that `artiq` and `nix-scripts` were both cloned to the `~/` directory.

> This command is equivalent to running `./shell-dev` from this repository. You may need to set `chmod +x` on this file to run it.

## Installing Vivado

_You need to install Vivado from within the nix-shell. See the preceding section if you have not started a nix shell!_

I first determined the Vivado version currently used by M-Labs when they build artiq.
I checked a recent build on the M-labs hydra server, e.g. https://nixbld.m-labs.hk/build/26018#tabs-build-deps, and found the `vivado` package listed in the build-deps.
This takes me to a [job](https://nixbld.m-labs.hk/build/24400#tabs-summary) where I can check the log and see the vivado version:
```
****** Vivado v2020.1 (64-bit)
  **** SW Build 2902540 on Wed May 27 19:54:35 MDT 2020
  **** IP Build 2902112 on Wed May 27 22:43:36 MDT 2020
    ** Copyright 1986-2020 Xilinx, Inc. All Rights Reserved.
```

Download the corresponding version and run the installer (remember to `sudo chmod +x` on the `.bin` so you can run it from terminal).

* Note that there are two product families, the *Lab* and *ML* versions. If you don't have access to a Vivado license key, you have to install the *Lab* version.

* Remember to uncheck `Install cable drivers` during the installation (as per the Artiq installation manual's advice). This seems to be the default option for Vivado 2020.1.

* Artiq expects the installation goes into e.g. `/opt/Xilinx/Vivado/2020.1`, but in reality you can install where ever you choose and set up a symbolic link afterwards, using e.g. `sudo ln -sf /tools/Xilinx/Vivado_Lab/2021.1 /opt/Xilinx/Vivado/2020.1`.

> Note: If making a new directory for installation, by default it won't have write access for all users so the installer will not be able to complete.
> You can view file permissions in linux by using `ls -lha`, and set write permissions for all users by using `chmod a+w <dir>`.

### Headless install

On some versions of Ubuntu you cannot install through the GUI - you will receive an error saying `no splash screen available` and the installer will hang. If this happens you can install headless by following the guide [here](https://forums.xilinx.com/t5/Installation-and-Licensing/Installation-of-Vivado-2020-1-under-Centos-7-8-fails/td-p/1115482).

First, unpack the installer:
```
./Xilinx_Unified_2020.1_0602_1208_Lin64.bin --target unpack --noexec
cd unpack
```
From this folder, you can create an install configuration and authorization token.
```
sudo ./xsetup -b AuthTokenGen
./xsetup -b ConfigGen
```
This generates the AuthToken and Config in your home directory under the `~/.Xilinx/` directory
Finally, invoke the installer itself, using your configuration as input:
```
sudo ./xsetup --batch Install --agree XilinxEULA,3rdPartyEULA,WebTalkTerms --location /artiq/xilinx/Vivado/2020.1 --config "/home/labadmin/.Xilinx/install_config.txt"
```
where the user here was `labadmin`. This installs into the `artiq/xilinx/Vivado/2020.1` folder. You would then use `sudo ln -sf /artiq/xilinx/Vivado/2020.1/Vivado/2020.1 /opt/Xilinx/Vivado/2020.1` to set the symlink in the expected format.

## Build desired gateware

A gateware target is built by running the corresponding python file:
```
python -m kasli_main
```
By default the output is placed into a folder of the same name as the module (here: `kasli_main`)
